-- 神域试炼boss技能
Lua_DivineDomainTrialBossSkillItem = class("Lua_DivineDomainTrialBossSkillItem", Lua_DisplayObject);
function Lua_DivineDomainTrialBossSkillItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_DivineDomainTrialBossSkillItem:buildShowItem()
	self:superCall("buildShowItem");

	self.skillItem = Lua_SkillIconItem.new(self.content);
	self.skillItem:setCanClick(true);
	self.skillItem:setScale(0.8, 0.8);

	self.weaknessIcon = UICreate.createUIAtlasImage(self.content, "divineDomainTrial_atlas", "xui_sysl_label_5", -32, 0, 26, 58);
end

function Lua_DivineDomainTrialBossSkillItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	local config = Lua_SkillConfigData.getConfigData(data);
	if config ~= nil then
		self.skillItem:setData(config);
		self.weaknessIcon:setEnable(config.bWeakness)
	end
end

function Lua_DivineDomainTrialBossSkillItem:setSkillItemScale(scale)
	if self.skillItem ~= nil then
		self.skillItem:setScale(scale, scale);
	end
end

function Lua_DivineDomainTrialBossSkillItem:setCanClick(value)
	value = value == true and true or false; 
	self.skillItem:setCanClick(value);
end

function Lua_DivineDomainTrialBossSkillItem:dispose()
	if self.weaknessIcon ~= nil then
		self.weaknessIcon:dispose();
		self.weaknessIcon = nil;
	end
	if self.skillItem ~= nil then
		self.skillItem:dispose();
		self.skillItem = nil;
	end
	self:superCall("dispose");
end