-- 神域试炼 普通类型试炼
checkRequire("Lua_DivineDomainTrialBossSkillItem");
checkRequire("Lua_DivineDomainTrialCommonItem");
Lua_DivineDomainTrialCommonPanel = class("Lua_DivineDomainTrialCommonPanel", Lua_DisplayObject);
function Lua_DivineDomainTrialCommonPanel:ctor(p)
	self:superCall("ctor", p, "DivineDomainTrialCommonPanel_skin");
end

function Lua_DivineDomainTrialCommonPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.diffObj:SetActive(false);
	self.specialObj:SetActive(false);
	self.dragList = Lua_DragList.new(self.botttomObj, 690, 297, Lua_AxisDefine.Vertical);
	self.dragList:setListCell(Lua_DivineDomainTrialCommonItem, 683, 127, 1);
	self.dragList:setRectAnchor(7);
	self.dragList:setRectPivot(7);
	self.dragList:setLocation(4, -478, 0);
	self.dragList:setCellSpacing(0, 10);

	self:createRedPoint(true);
	self.tipSp:addClickFuntion(self, self.onClickTipSp);
	self.addBuffSp:addClickFuntion(self, self.onClickAddBuffSp);
    self.achievementSp:addClickFuntion(self, self.onClickAchievementSp);
    self.recommendSp:addClickFuntion(self, self.onClickRecommendSp);
    self.fightBtn:addClickFuntion(self, self.onClickFightBtn);

    self:addLuaEvent("UPDATE_DIVINEDOMAINTRIAL_SELECTED_BUFF", self, self.updateSelectedBuff); -- 刷新buff
    self:addLuaEvent("UPDATE_DIVINEDOMAINTRIAL_TRIAL_DATA", self, self.updateTrialData); -- 刷新关卡数据
end

-- function Lua_DivineDomainTrialCommonPanel:onScreenResize(adaptHeight)
-- 	if self.adaptHeight ~= adaptHeight then
-- 		self:superCall("onScreenResize", adaptHeight);
-- 		-- self.dragList:setContentRect(690, 368 + adaptHeight);
-- 		-- self:adpateShow();
-- 	end
-- end

function Lua_DivineDomainTrialCommonPanel:dispose()
	DataCenter.preLoadData:removeBySign("Lua_FightLineupWindow", self, self.onSceneShow);
	self:endTimer();
	if self.redPointIcon ~= nil then
		self.redPointIcon:dispose();
		self.redPointIcon = nil;
	end
	if self.skillItems ~= nil then
		for i = 1, #self.skillItems do
			self.skillItems[i]:dispose();
			self.skillItems[i] = nil;
		end
		self.skillItems = nil;
	end
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	if self.hurtNumImage ~= nil then
		self.hurtNumImage:dispose();
		self.hurtNumImage = nil;
	end
	if self.selectedBuff ~= nil then
		self.selectedBuff:dispose();
		self.selectedBuff = nil;
	end
	self:superCall("dispose");
end

function Lua_DivineDomainTrialCommonPanel:createRedPoint(bShow)
	if not bShow then
		if self.redPointIcon ~= nil then
			self.redPointIcon:changeRedPoint(nil);
		end
	else
		if self.redPointIcon == nil then
			self.redPointIcon = Lua_RedPointIcon.new(self.content);
			self.redPointIcon:setLocation(322, -218);
			self.redPointIcon:setRectAnchor(1);
		end
		self.redPointIcon:changeRedPoint(Lua_RedPointList.DivineDomainTrial_Special_Reward, Lua_RedPointList.DivineDomainTrial_Achieve_Reward);
	end
end

function Lua_DivineDomainTrialCommonPanel:onClickAchievementSp()	
	if not DataCenter.divineDomainTrialData:checkTrialOpened(self.trialId, true) then
		return;
	end

	-- 成就奖励
	Lua_WindowUtil.openWin("Lua_DivineDomainTrialRewardWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_DivineDomainTrialCommonPanel:onClickRecommendSp()	
	if not DataCenter.divineDomainTrialData:checkTrialOpened(self.trialId, true) then
		return;
	end

	if self.clickTime ~= nil and getTime() - self.clickTime < 0.5 then
		OperateAlert.showLangValue(764012);
		return;
	end
	self.clickTime = getTime();

	-- 阵容推荐申请 最低通关记录 再打开
	local trialData = DataCenter.divineDomainTrialData:getDivineDomainTrialData(self.trialId);
	if trialData == nil then
		return;
	end
	local levelId = trialData.maxFightingLevel;
	Lua_ProxyManager.getProxy("Lua_DivineDomainTrialProxy"):sGetRecommendInfo(levelId);
end

function Lua_DivineDomainTrialCommonPanel:onClickAddBuffSp()
	if not DataCenter.divineDomainTrialData:checkTrialOpened(self.trialId, true) then
		return;
	end

	-- 打开buff窗口
	Lua_WindowUtil.openWin("Lua_DivineDomainTrialBuffWindow", Lua_WinParam.ACTION_OPEN, self.trialId);
end

function Lua_DivineDomainTrialCommonPanel:setData(data)
	self.trialId = data;

	self.bSpecialTrial = DataCenter.divineDomainTrialUtil:checkSpecialTrial(self.trialId);
	self:showBoss();
	self:updateSelectedBuff();
	self:endTimer();
	self:startTimer();
	self:showSpecialTrialDisplay();
	self:updateFreeCount();
	self:updateList();
	self:updateSkills();
	-- self:moveToIndex();
end

function Lua_DivineDomainTrialCommonPanel:updateTrialData()
	self:updateFreeCount();
	self:updateList();
	self:showSpecialTrialDisplay();
	self:updateSelectedBuff();
end

function Lua_DivineDomainTrialCommonPanel:showBoss()
	Lua_MsgUtil.callFunc("DIVINEDOMAIN_TRIAL_SHOW_MODEL", self.trialId);
end

function Lua_DivineDomainTrialCommonPanel:startTimer()
	if self.bTimer ~= true then
		self.bTimer = true;
		local trialData = DataCenter.divineDomainTrialData:getDivineDomainTrialData(self.trialId);
		if trialData == nil then
			return;
		end

		self.clockTime = trialData.clockTime;
		self:addTimer("Lua_DivineDomainTrialCommonPanel", 1, self, self.updateResidueTime);
		self:updateResidueTime();
	end
end

function Lua_DivineDomainTrialCommonPanel:updateResidueTime()
	local time = self.clockTime - DataCenter.roleData.serverTime;
	if time <= 0 then
		time = 0;
		self:endTimer();
	end
	local str;
	if self.bSpecialTrial then
		str = LanUtil.getValue(764017);
	else
		str = LanUtil.getValue(764018);
	end
	self.timeTxt.text = LanUtil.formateStr(str, Lua_TimeTransform.transSeconds16(time, true, true, true));
end

function Lua_DivineDomainTrialCommonPanel:endTimer()
	if self.bTimer == true then
		self.bTimer = false;
		self:removeTimer(self, self.updateResidueTime);
	end
end

function Lua_DivineDomainTrialCommonPanel:showSpecialTrialDisplay()
	self.buffTipTxt.text = self.bSpecialTrial and LanUtil.getValue(764019) or LanUtil.getValue(764020);
	self.recommendSp:setEnable(not self.bSpecialTrial);
	self.specialObj:SetActive(self.bSpecialTrial);
	self.diffObj:SetActive(self.bSpecialTrial);
	if self.bSpecialTrial then
		local hurtValue;
		local specialTrialData = DataCenter.divineDomainTrialData:getSpecialTrialData();
		if specialTrialData == nil then
			return;
		end

		if specialTrialData.diffLevel == 1 then
			self.specialDiffTxt.text = nil;
			self.specialDiffBg:setEnable(false);
		else
			self.specialDiffTxt.text = LanUtil.formateStr(764021, specialTrialData.diffLevel);
			self.specialDiffBg:setEnable(true);
		end
		
		local trialData = DataCenter.divineDomainTrialData:getDivineDomainTrialData(self.trialId);
		if not DataCenter.divineDomainTrialUtil:checkLastLevel(trialData.maxFightingLevel) then
			self.hurtBar:setMaxValue(100);
			self.hurtBar:setValue(specialTrialData.bossHP);
			self.hurtBar:setEnable(true);
			local value = specialTrialData.bossHP;
			if value < 1 then
				value = string.format("%.1f", value);
			else
				value = Mathf.Floor(value);
			end
			self.hurtBar:setText(LanUtil.formateStr(764022, value));
			self.challengeObj:SetActive(false);
		else
			self.hurtBar:setEnable(false);
			self.challengeObj:SetActive(true);
			hurtValue = specialTrialData.hurtValue;
		end
		self:showHurtValue(hurtValue);
	end
end

function Lua_DivineDomainTrialCommonPanel:showHurtValue(value)
	if value then
		if self.hurtNumImage == nil then
			self.hurtNumImage = Lua_NumberImage.new(self.challengeObj);
			self.hurtNumImage:setLocation(-45, -10.4, 0);
			self.hurtNumImage.pivot = 1;
			self.hurtNumImage.numOffsetX = -2;
			self.hurtNumImage.numAtlas = "number";
			self.hurtNumImage.preStr = "xui_zl1_number_0";
		end
		self.hurtNumImage:setEnable(true);
		self.hurtNumImage.num = value;
	else
		if self.hurtNumImage ~= nil then
			self.hurtNumImage:setEnable(false);
		end
	end
end

function Lua_DivineDomainTrialCommonPanel:updateList()
	local cfg = DataCenter.divineDomainTrialUtil:getDivineDomainTrialConfig(self.trialId);
	if cfg == nil then
		return;
	end

	if self.titleImg.url ~= cfg.titleUrl then
		self.titleImg:SetDimensions(0, 0);
		self.titleImg:setUrl(cfg.titleUrl);
	end


	local difficult = 1;
	local specialTrialData = DataCenter.divineDomainTrialData:getSpecialTrialData();
	if specialTrialData ~= nil then
		difficult = specialTrialData.diffLevel;
	end
	local list = DataCenter.divineDomainTrialUtil:getDivineDomainTrialLevelIdsByTrialId(self.trialId, difficult);
	list = list or {};
	self.dragList:setArrayData(list);
	self:moveToIndex();
end

function Lua_DivineDomainTrialCommonPanel:moveToIndex()
	local index = DataCenter.divineDomainTrialUtil:getLevelIndexByTrialId(self.trialId);
	self.dragList:moveToIndex(index, true);
end

function Lua_DivineDomainTrialCommonPanel:updateFreeCount()
	local totalCount;
	local count = DataCenter.divineDomainTrialData:getCountDicByTrialId(self.trialId) or 0;
	if self.bSpecialTrial then
		totalCount = getConfig("domain_trial_const", "special_free_count", "value");
	else
		totalCount = getConfig("domain_trial_const", "orgintrial_free_count", "value"); 
	end

	local langId = count > 0 and 764023 or 764044
	self.freeCountTxt.text = LanUtil.formateStr(langId, count, totalCount);
end

function Lua_DivineDomainTrialCommonPanel:updateSkills()
	if self.trialId == nil then
		return;
	end

	local skills;
	if self.bSpecialTrial then
		local specialTrialData = DataCenter.divineDomainTrialData:getSpecialTrialData();
		if specialTrialData == nil then
			return;
		end
		skills = specialTrialData.skills;
	else
		skills = DataCenter.divineDomainTrialUtil:getShowSkillByTrialId(self.trialId); 
	end
	skills = skills or {};

	if self.skillItems == nil then
		self.skillItems = {};
	end

	local item;
	local posX, posY;
	local startPosX, startPosY, distance = -285, 426, 100;
	for i = 1, #skills do
		item = self.skillItems[i];
		if item == nil then
			item = Lua_DivineDomainTrialBossSkillItem.new(self.leftObj);
			item:setRectAnchor(1);
			self.skillItems[i] = item;
		end

		posX = startPosX;
		posY = startPosY - (i - 1) * distance;
		item:setData(skills[i]);
		item:setLocation(posX, posY);
		item:setEnable(true);
	end

	if #skills < #self.skillItems then
		for i = #skills + 1, #self.skillItems do
			self.skillItems[i]:setEnable(false);
		end
	end
end

function Lua_DivineDomainTrialCommonPanel:updateSelectedBuff()
	local buffId = DataCenter.divineDomainTrialData:getBuffDicByTrialId(self.trialId);
	if buffId ~= nil and buffId ~= 0 then
		if self.selectedBuff == nil then
			self.selectedBuff = Lua_DivineDomainTrialBossSkillItem.new(self.leftObj);
			self.selectedBuff:setCanClick(false)
			self.selectedBuff:setRectAnchor(1);
			self.selectedBuff:setLocation(-284, 76);
		end
		self.selectedBuff:setData(buffId);
		self.selectedBuff:setEnable(true);
	else
		if self.selectedBuff ~= nil then
			self.selectedBuff:setEnable(false);
		end
	end
end

function Lua_DivineDomainTrialCommonPanel:onClickTipSp(go)
	if not DataCenter.divineDomainTrialData:checkTrialOpened(self.trialId, true) then
		return;
	end

	local cfg = DataCenter.divineDomainTrialUtil:getDivineDomainTrialConfig(self.trialId);
	if cfg == nil then
		return;
	end


	local tipData = { des = cfg.tip_txt, posX = 185, posY = -226 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

function Lua_DivineDomainTrialCommonPanel:onClickFightBtn()
	if not DataCenter.divineDomainTrialData:checkTrialOpened(self.trialId, true) then
		return;
	end

	if self.clickTime ~= nil and getTime() - self.clickTime < 0.5 then
		OperateAlert.showLangValue(764012);
		return;
	end
	self.clickTime = getTime();

	local cfg = DataCenter.divineDomainTrialUtil:getDivineDomainTrialConfig(self.trialId);
	local template_id = cfg.fight_id;
	local trialData = DataCenter.divineDomainTrialData:getSpecialTrialData();
	local diffLevel = trialData ~= nil and trialData.diffLevel or 1;
	local levelIndex = cfg.level_list ~= nil and cfg.level_list[diffLevel] or 1;
	self.levelId = DataCenter.divineDomainTrialUtil:getLevelIdByTrialIdAndDiff(self.trialId, diffLevel, levelIndex)
	cfg =  DataCenter.divineDomainTrialUtil:getDivineDomainTrialLevelConfig(self.levelId);
	self.monsterId = cfg.monster

	local sceneId = DataCenter.heroLineupData:getFightLineupSceneId(template_id);
	DataCenter.preLoadData:preShowScene("Lua_FightLineupWindow", Lua_PreLoadDefine.LOADSHOW_TYPE_NONE, self, self.onSceneShow, template_id, sceneId, 0);
end

function Lua_DivineDomainTrialCommonPanel:onSceneShow(param)
	local data = { template_id = param, stage_id = self.levelId, monster_player_id = self.monsterId };
	Lua_WindowUtil.openWin("Lua_FightLineupWindow", Lua_WinParam.ACTION_OPEN, data);
end