-- 神域试炼
checkRequire("Lua_DivineDomainTrialItemTopPanel");
checkRequire("Lua_DivineDomainTrialCommonPanel");
Lua_DivineDomainTrialControlPanel = class("Lua_DivineDomainTrialControlPanel", Lua_DisplayObject);
function Lua_DivineDomainTrialControlPanel:ctor(p)
	self:superCall("ctor", p);
end

function Lua_DivineDomainTrialControlPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.panelInfo = Array();
	self.panelInfo:add({panel = Lua_DivineDomainTrialCommonPanel, trialId = 5, sceneId = 40114, index = self.panelInfo:getSize() + 1 }) -- 混合灵
	self.panelInfo:add({panel = Lua_DivineDomainTrialCommonPanel, trialId = 4, sceneId = 40114, index = self.panelInfo:getSize() + 1 }) -- 假象灵
	self.panelInfo:add({panel = Lua_DivineDomainTrialCommonPanel, trialId = 1, sceneId = 40114, index = self.panelInfo:getSize() + 1 }) -- 虚空灵
	self.panelInfo:add({panel = Lua_DivineDomainTrialCommonPanel, trialId = 3, sceneId = 40114 ,index = self.panelInfo:getSize() + 1 }) -- 吞噬灵
	self.panelInfo:add({panel = Lua_DivineDomainTrialCommonPanel, trialId = 2, sceneId = 40114, index = self.panelInfo:getSize() + 1 }) -- 双生灵

	self.panelDic = {};
	self.trialItemList = Lua_DragList.new(self.content, 720, 119, Lua_AxisDefine.Horizontal);
	self.trialItemList:setListCell(Lua_DivineDomainTrialItem, 294, 127, 1);
	self.trialItemList:setRectAnchor(7);
	self.trialItemList:setRectPivot(6);
	self.trialItemList:setLocation(-360, 114, 0);
	self.trialItemList:setCellSpacing(0, 10);
	self.trialItemList:setArrayData(self.panelInfo);

	self.topSplitSp = UICreate.createUIAtlasImage(self.content, "divineDomainTrial_atlas", "xui_sysl_window_18", 0, 234, 720, 2);
	self.topSplitSp.anchorValue = 7;


	local resourceIds = DataCenter.divineDomainTrialUtil:getDivineDomainTrialResource();
	self.itemsPanel = Lua_DivineDomainTrialItemTopPanel.new(self.content);
	self.itemsPanel:setRectAnchor(1);
	self.itemsPanel:setData(resourceIds);

	self:addLuaEvent("SELECT_DIVINEDOMAIN_TRIAL", self, self.selectedPanel);
	self:addLuaEvent("DIVINEDOMAIN_TRIAL_OPENTIP_WINS", self, self.openTipWins);
end

function Lua_DivineDomainTrialControlPanel:onScreenResize(adaptHeight)
	if self.adaptHeight ~= adaptHeight then
		self:superCall("onScreenResize", adaptHeight);
		if self.showPanel ~= nil and self.showPanel.onScreenResize ~= nil then
			self.showPanel:onScreenResize(adaptHeight);
		end
	end
end

-- panel加载完后在 选择页签
function Lua_DivineDomainTrialControlPanel:selectedTabIndex()
	Lua_MsgUtil.callFunc("DIVINEDOMAIN_TRIAL_SELECT_TRIAL_TAB");
end

function Lua_DivineDomainTrialControlPanel:updateData()
	if self.selectedIndex ~= nil then
		local data = self.panelInfo[self.selectedIndex];
		trialId = data.trialId;
		Lua_MsgUtil.callFunc("DIVINEDOMAIN_TRIAL_SHOW_MODEL", trialId);
	else
		self:selectedTabIndex();
	end
end

function Lua_DivineDomainTrialControlPanel:selectedPanel(index)
	if self.selectedIndex == nil then
		self.trialItemList:moveToIndex(index, true);
		self.trialItemList:setSelected(index);
	end

	if self.selectedIndex == index then
		return;
	end

	self.selectedIndex = index;
	local data = self.panelInfo[index];
	self.trialId = data.trialId;
	local cfg = DataCenter.divineDomainTrialUtil:getDivineDomainTrialConfig(self.trialId);
	if cfg == nil then
		return;
	end

	local curPanel;
	local panelStr = data.panel;
	if panelStr ~= nil then	
		if self.panelDic[panelStr] ~= nil then
			curPanel = self.panelDic[panelStr];
		else
			curPanel = panelStr.new(self.content);
			curPanel:setSiblingIndex(0);
			curPanel:setRectAnchor(9);
			self.panelDic[panelStr] = curPanel;
		end

		if self.showPanel ~= curPanel then
			if self.showPanel ~= nil then
				self.showPanel:setEnable(false);
			end
		end

		curPanel:setEnable(true);
		curPanel:setData(self.trialId);
		self.showPanel = curPanel;
		self:openTipWins();
	end
end

function Lua_DivineDomainTrialControlPanel:openTipWins(bShow)
	local bSpecialTrial = DataCenter.divineDomainTrialUtil:checkSpecialTrial(self.trialId);
	local bFirstOpen = DataCenter.divineDomainTrialData:getOpenedDicByTrialId(self.trialId) ~= true;
	if bFirstOpen then
		DataCenter.divineDomainTrialData:setOpenedDicByTrialId(self.trialId, true)

		self:openBuffsWin(self.trialId);
		if bSpecialTrial and DataCenter.divineDomainTrialData.bShowNoticeBossSkillChange == 0 then
			Lua_WindowUtil.openWin("Lua_DivineDomainTrialSpecialBossTipWindow", Lua_WinParam.ACTION_OPEN);
		end
	else
		if bSpecialTrial and bShow then
			self:openBuffsWin(self.trialId);
		end
	end
end

-- 打开增益选择窗口
function Lua_DivineDomainTrialControlPanel:openBuffsWin(trialId)
	local selectedBuffId = DataCenter.divineDomainTrialData:getBuffDicByTrialId(trialId);
	if selectedBuffId == nil or selectedBuffId == 0 then
		-- 打开增益窗口
		Lua_WindowUtil.openWin("Lua_DivineDomainTrialBuffWindow", Lua_WinParam.ACTION_OPEN, trialId);
	end
end

function Lua_DivineDomainTrialControlPanel:dispose()
	if self.topSplitSp ~= nil then
		self.topSplitSp:dispose();
		self.topSplitSp = nil;
	end
	if self.panelInfo ~= nil then
		self.panelInfo:dispose();
		self.panelInfo:clear();
		self.panelInfo = nil;
	end
	if self.itemsPanel ~= nil then
		self.itemsPanel:dispose();
		self.itemsPanel = nil;
	end
	if self.trialItemList ~= nil then
		self.trialItemList:dispose();
		self.trialItemList = nil;
	end
	if self.panelDic ~= nil then
		for k, v in pairs(self.panelDic) do
			v:dispose();
			v = nil;
		end
		self.panelDic = nil;
	end
	self.showPanel = nil;
	self:superCall("dispose");
end

















-------------------------------------------
Lua_DivineDomainTrialItem = class("Lua_DivineDomainTrialItem", Lua_ListCell);
function Lua_DivineDomainTrialItem:ctor(p)
	self:superCall("ctor", p, "DivineDomainTrialItem_skin");
end

function Lua_DivineDomainTrialItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_DivineDomainTrialItem:dispose()
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self:superCall("dispose");
end

function Lua_DivineDomainTrialItem:setData(data)
	self.data = nil;
	if data == nil then
		return;
	end

	self.data = data.trialId;
	self.tabIndex = data.index;
	local cfg = DataCenter.divineDomainTrialUtil:getDivineDomainTrialConfig(self.data);
	if cfg == nil then
		return;
	end

	if self.monsterImg.url ~= cfg.tabUrl then
		self.monsterImg:SetDimensions(0, 0);
		self.monsterImg:setUrl(cfg.tabUrl);
	end
	self.trialNameTxt.text = cfg.name;
	local openTipStr;
	local trialData = DataCenter.divineDomainTrialData:getDivineDomainTrialData(self.data);
	self.bOpened = nil;
	if trialData ~= nil then
		self.bOpened = trialData.bOpened;
	end

	self.bSpecialTrial = DataCenter.divineDomainTrialUtil:checkSpecialTrial(self.data);
	self:showRedPoint(self.bOpened and cfg.red_id or nil);

	if not self.bOpened then
		openTipStr = cfg.open_str;
	else
		openTipStr = LanUtil.getValue(764011);
	end
	self.timeTxt.text = openTipStr;
end

function Lua_DivineDomainTrialItem:onPressClick()
	if not self.bOpened then
		local cfg = DataCenter.divineDomainTrialUtil:getDivineDomainTrialConfig(self.data);
		if cfg ~= nil then
			OperateAlert.show(cfg.open_str);
		end
		return false;
	end

	if self.clickTime ~= nil and getTime() - self.clickTime < 0.5 then
		return;
	end
	self.clickTime = getTime();

	if self.data ~= nil then
		Lua_MsgUtil.callFunc("SELECT_DIVINEDOMAIN_TRIAL", self.tabIndex);
		return true;
	end
end

function Lua_DivineDomainTrialItem:onSelectionChange(bSelect)
	self:superCall("onSelectionChange", bSelect);

	local tipColorStr;
	local nameColorStr;
	if bSelect then
		tipColorStr = self.bOpened and "63bd7d" or "ddccc2";
		nameColorStr = "fff4c6";
	else
		tipColorStr = self.bOpened and "63bd7d" or "a1a5ad";
		nameColorStr = "cdaf87";
	end
	self.timeTxt.colorStr = Lua_ColorDefine.transColor(tipColorStr);
	self.trialNameTxt.colorStr = Lua_ColorDefine.transColor(nameColorStr);


	local sprite;
	if self.bSpecialTrial then
		sprite = bSelect and "xui_sysl_toggle_2_f" or "xui_sysl_toggle_2_b";

		local specialSprite = bSelect and "xui_sysl_window_23" or "xui_sysl_window_22";
		self.specialSp:setAltas("divineDomainTrial_atlas", specialSprite);
	else
		sprite = bSelect and "xui_sysl_toggle_1_f" or "xui_sysl_toggle_1_b";
	end
	self.specialSp:setEnable(self.bSpecialTrial);
	self.itemBg:setAltas("divineDomainTrial_atlas", sprite);
end

function Lua_DivineDomainTrialItem:showRedPoint(redId)
	if self.redPoint == nil then
		self.redPoint = Lua_RedPointIcon.new(self.content, redId);
		self.redPoint:setLocation(123, 47)
	else
		self.redPoint:changeRedPoint(redId)
	end
end