-- 神域试炼入口
checkRequire("Lua_DivineDomainTrialItemTopPanel");
Lua_DivineDomainTrialEntranceWindow = class("Lua_DivineDomainTrialEntranceWindow", Lua_Window);
function Lua_DivineDomainTrialEntranceWindow:ctor()
	self:superCall("ctor");

	self.showBlackMask = true;
	self.showBackBtn = true;
	self.isFullSizeWin = true;
	self.showWinBg = true;
	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
	self.windowName = "Lua_DivineDomainTrialEntranceWindow";
	self.skinName = "DivineDomainTrialEntranceWindow_skin";
	self.winBgPath = "/images/divineDomainTrial/xui_sysl_bg_1.jpg";
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
end

function Lua_DivineDomainTrialEntranceWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.winBg.anchorValue = 4;
	self.winBg:setLocation(0, 900);
	self.panelInfo = Array();
	self.panelInfo:add({ trialId = 5, subTabIndex = 1 }) -- 混合灵
	self.panelInfo:add({ trialId = 1, subTabIndex = 3 }) -- 假象灵
	self.panelInfo:add({ trialId = 2, subTabIndex = 5 }) -- 虚空灵
	self.panelInfo:add({ trialId = 3, subTabIndex = 4 }) -- 吞噬灵
	self.panelInfo:add({ trialId = 4, subTabIndex = 2 }) -- 双生灵

	local resourceIds = DataCenter.divineDomainTrialUtil:getDivineDomainTrialResource();
	self.itemsPanel = Lua_DivineDomainTrialItemTopPanel.new(self.content);
	self.itemsPanel:setRectAnchor(1);
	self.itemsPanel:setData(resourceIds);

	self.downBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_widget_005", 0, 0, 720, 121);
	self.downBg.pivot = Lua_WindowUtil.getPivot(7);
	self.downBg.anchor = Lua_WindowUtil.getAnchor(7);
	self.downBg:setLocation(0, -5, 0);
	self.downBg.siblingIndex = self.backBtn.siblingIndex;

	self.tipSp:addClickFuntion(self, self.onTipSpClick);
	self:updateEntranceItems();

	self:addLuaEvent("UPDATE_DIVINEDOMAINTRIAL_TRIAL_DATA", self, self.updateEntranceItems); -- 刷新入口数据
	self:addLuaEvent("NOTICE_RESET_DIVINEDOMAINTRIAL", self, self.noticeReset); -- 通知神域试炼每日刷新

	self:noticeReset(); -- 检测跨天更新
end

function Lua_DivineDomainTrialEntranceWindow:dispose()
	if self.downBg ~= nil then
		self.downBg:dispose();
		self.downBg = nil;
	end
	if self.itemsPanel ~= nil then
		self.itemsPanel:dispose();
		self.itemsPanel = nil;
	end
	if self.entranceItemDic ~= nil then
		local item;
		for i = 1, #self.entranceItemDic do
			item = self.entranceItemDic[i];
			item:dispose();
			item = nil;
		end
		self.entranceItemDic = nil;
	end
	self:superCall("dispose");
end

function Lua_DivineDomainTrialEntranceWindow:updateEntranceItems()
	if self.entranceItemDic == nil then
		self.entranceItemDic = {};
	end

	local item;
	for i = 1, self.panelInfo:getSize() do
		item = self.entranceItemDic[i];
		if item == nil then
			item = Lua_DivineDomainTrialEntranceItem.new(self.content);
			item:setData(self.panelInfo[i]);
			self.entranceItemDic[i] = item;
		else
			item:setData(self.panelInfo[i]);
		end
	end
end

function Lua_DivineDomainTrialEntranceWindow:onTipSpClick(go)
	local tipData = { des = DataCenter.divineDomainTrialUtil.divineDomainTrialTip, posX = 185, posY = -226 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

function Lua_DivineDomainTrialEntranceWindow:noticeReset()
	if not Lua_WindowUtil.isOpenWin("Lua_DivineDomainTrialMainWindow") then
		DataCenter.divineDomainTrialData:resetSendMSg();
	end
end









------------------------------------------


Lua_DivineDomainTrialEntranceItem = class("Lua_DivineDomainTrialEntranceItem", Lua_DisplayObject);
function Lua_DivineDomainTrialEntranceItem:ctor(p)
	self:superCall("ctor", p, "DivineDomainTrialEntranceItem_skin");
end

function Lua_DivineDomainTrialEntranceItem:buildShowItem()
	self:superCall("buildShowItem");

	self.preSignStr = "Lua_DivineDomainTrialMainWindow";
    self.clickRewardSp:addClickFuntion(self, self.onClickSelectSp);
    self.itemBg.clickScale = false;
    self.itemBg:addMousDownFuntion(self, self.onMouseDownItemBg);
	self.itemBg:addMouseUpFuntion(self, self.onMouseUpItemBg);
end

function Lua_DivineDomainTrialEntranceItem:dispose()
	self:removePreLoad();
	self:stopTimer();
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	if self.preItems ~= nil then
		for i = 1, #self.preItems do
			self.preItems[i]:dispose();
			self.preItems[i] = nil;
		end
		self.preItems = nil;
	end
	self:superCall("dispose");
end

function Lua_DivineDomainTrialEntranceItem:setData(data)
	self.data = data;

	if data == nil then
		return;
	end

	self.trialId = data.trialId;
	local cfg = DataCenter.divineDomainTrialUtil:getDivineDomainTrialConfig(self.trialId);
	if cfg == nil then
		return;
	end
	local width = cfg.item_rect ~= nil and #cfg.item_rect > 0 and cfg.item_rect[1] or 0;
	local height = cfg.item_rect ~= nil and #cfg.item_rect > 1 and cfg.item_rect[2] or 0;
	local posX = cfg.pos ~= nil and #cfg.pos > 0 and cfg.pos[1] or 0;
	local posY = cfg.pos ~= nil and #cfg.pos > 1 and cfg.pos[2] or 0;
	local anchor = cfg.itemAnchor or 1;
	local itemUrl = cfg.imageUrl or "/images/activities/xui_xz_widget_8.png";
	local nameStr = cfg.name or "";
	local items = cfg.preview_items or {};
	self:setRectSize(width, height);
	self:setLocation(posX, posY);
	self:setRectAnchor(anchor);
	self.itemBg:setUrl(itemUrl);
	self.itemBg:SetDimensions(width, height);
	-- self.itemList:setArrayData(items);
	self:updatePreviewItem(items)

	local trialData = DataCenter.divineDomainTrialData:getDivineDomainTrialData(self.trialId);
	if trialData == nil then
		return;
	end

	local bSpecialTrial = DataCenter.divineDomainTrialUtil:checkSpecialTrial(self.trialId);
	local effectColorStr = cfg.desc_color or "5e3732";
	if not trialData.bOpened then
		self.timeTxt.text = cfg.open_str;
		self:stopTimer();
	else
		if bSpecialTrial then
			self.clockTime = trialData.clockTime or 0;
			self:onTimer();
			self:startTimer();
		else
			self:stopTimer();
			self.timeTxt:setLangValue(764010);
		end
		effectColorStr = "976e29";
	end
	self.timeTxt.effectColorStr = Lua_ColorDefine.transColor(effectColorStr);
 	
 	local bOpened = DataCenter.divineDomainTrialData:checkTrialOpened(self.trialId, false);
	self:showRedPoint(bOpened and cfg.red_id or nil, cfg.red_points);

	local posY;
	if bSpecialTrial then
		posY = -190;
	else
		posY = -89;
	end
	self.timeTxt:setLocation(-30, posY);
end

function Lua_DivineDomainTrialEntranceItem:updatePreviewItem(pre_items)
	if self.preItems == nil then
		self.preItems = {};
	end

	local item;
	local len = 0;
	if pre_items ~= nil then
		len = #pre_items;
		local posX, startPosX, distance = 0, -49, 51;
		for i = 1, len do
			item = self.preItems[i];
			if item == nil then
				item = Lua_DivineDomainTrialSubItem.new(self.content);
				item:setRectAnchor(8);
				self.preItems[i] = item;
			end
			posX = startPosX - (i - 1) * distance;
			item:setLocation(posX, 41);
			item:setData(pre_items[i]);
			item:setEnable(true);
		end
	end

	if len < #self.preItems then
		for i = len + 1, #self.preItems do
			item = self.preItems[i];
			item:setEnable(false);
		end
	end
end

function Lua_DivineDomainTrialEntranceItem:onMouseDownItemBg()
	self:setScale(1.1, 1.1);
end

function Lua_DivineDomainTrialEntranceItem:onMouseUpItemBg()
	self:setScale(1, 1);
	self:onClickBgClick();
end

function Lua_DivineDomainTrialEntranceItem:onClickBgClick()
	local cfg = DataCenter.divineDomainTrialUtil:getDivineDomainTrialConfig(self.trialId);
	if cfg == nil then
		return;
	end

	local bOpened = DataCenter.divineDomainTrialData:checkTrialOpened(self.trialId, false);
	if not bOpened then
		OperateAlert.show(cfg.open_str);
		return;
	end

	local heroId = cfg.hero_id;
	local sceneId = cfg.scene_id;
	local heroVo = Lua_HeroVo.new(heroId);
	heroVo.uiSceneId = sceneId;
	DataCenter.preLoadData:preShowModelScene(self.preSignStr, Lua_PreLoadDefine.LOADSHOW_TYPE_NONE, self, self.onSceneShow, nil, heroVo);
end

function Lua_DivineDomainTrialEntranceItem:onSceneShow(param, modelScenePanel, isSuccess)
	self:removePreLoad();
	if isSuccess then
		local data = { main_id = 1, subTabIndex = self.data.subTabIndex, modelScenePanel = modelScenePanel}
		Lua_WindowUtil.openWin("Lua_DivineDomainTrialMainWindow", Lua_WinParam.ACTION_OPEN, data);
	end
end

function Lua_DivineDomainTrialEntranceItem:removePreLoad()
	DataCenter.preLoadData:removeBySign(self.preSignStr, self, self.onSceneShow)
end

function Lua_DivineDomainTrialEntranceItem:onClickSelectSp()
	Lua_WindowUtil.openWin("Lua_DivineDomainTrialPreviewRewardWindow", Lua_WinParam.ACTION_OPEN, self.trialId);
end

function Lua_DivineDomainTrialEntranceItem:showRedPoint(redId, red_points)
	if self.redPoint == nil then
		local posX = red_points ~= nil and red_points[1] or -28;
		local posY = red_points ~= nil and red_points[2] or -27;
		self.redPoint = Lua_RedPointIcon.new(self.content, redId);
		self.redPoint:setLocation(posX, posY);
		self.redPoint:setRectAnchor(2);
	else
		self.redPoint:changeRedPoint(redId)
	end
end

function Lua_DivineDomainTrialEntranceItem:startTimer()
	if self.bTimer ~= true then
		self.bTimer = true
		self:addTimer("Lua_DivineDomainTrialEntranceItem", 1, self, self.onTimer)
	end
end

function Lua_DivineDomainTrialEntranceItem:stopTimer()
	if self.bTimer == true then
		self.bTimer = false
		self:removeTimer(self, self.onTimer)
	end
end

function Lua_DivineDomainTrialEntranceItem:onTimer()
	local remainTime = self.clockTime - DataCenter.roleData.serverTime
	if remainTime > 0 then
		self.timeTxt:setEnable(true)
		self.timeTxt.text = LanUtil.formateStr(764054, Lua_TimeTransform.transSeconds1(remainTime));
	else
		self:stopTimer()
		self.timeTxt:setEnable(false)
	end
end







------------------------------------------

Lua_DivineDomainTrialSubItem = class("Lua_DivineDomainTrialSubItem", Lua_DisplayObject);
function Lua_DivineDomainTrialSubItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_DivineDomainTrialSubItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_DivineDomainTrialSubItem:dispose()
	self.data = nil;
	if self.iconSp ~= nil then
    	self.iconSp:dispose();
		self.iconSp = nil;
	end
	if self.iconSpBg ~= nil then
    	self.iconSpBg:dispose();
		self.iconSpBg = nil;
	end
	if self.iconImg ~= nil then
    	self.iconImg:dispose();
		self.iconImg = nil;
	end
	if self.iconItem ~= nil then
    	self.iconItem:dispose();
		self.iconItem = nil;
	end

	self:superCall("dispose");
end

function Lua_DivineDomainTrialSubItem:setData(data)
	self.data = data;

	if data == nil then
		return;
	end
	self:updateDisplay();
end

function Lua_DivineDomainTrialSubItem:updateDisplay()
	if self.data ~= nil then
		local type = self.data[1];
		if self.iconSp ~= nil then
			self.iconSp:setEnable(type == 1);
			self.iconSpBg:setEnable(type == 1);
		end

		if self.iconImg ~= nil then
			self.iconImg:setEnable(type == 2);
		end

		if self.iconItem ~= nil then
			self.iconItem:setEnable(type == 3);
		end

		if type == 1 then
			if self.iconSp == nil then
				self.iconSpBg = UICreate.createUIAtlasImage(self.content, "divineDomainTrial_atlas", "xui_sysl_widget_29", 0, 0, 50, 50);
				self.iconSp = UICreate.createUIAtlasImage(self.content, self.data[2], self.data[3], 0, 0, 92, 92);
				self.iconSp:setScale(0.45, 0.45);
			else
				self.iconSp:setAltas(self.data[2], self.data[3]);
			end
			self.iconSp:setEnable(true);
		elseif type == 2 then
			if self.iconImg == nil then
				self.iconImg =  UICreate.createImage(self.content, self.data[2], 0, 0, 92, 92);
				self.iconImg:setScale(0.45, 0.45);
			else
				self.iconImg:setUrl(self.data[2]);
			end
			self.iconImg:setEnable(true);
		elseif type == 3 then
			if self.iconItem == nil then
				self.iconItem =  Lua_ItemIcon.new(self.content);
				self.iconItem:setScale(0.35, 0.35);
				self.iconItem:setLocation(0, 0);
			end

			local tvo = Lua_ToolVo.createToolVo(self.data[2]);
			self.iconItem:setData(tvo);
			self.iconItem:setEnable(true);
		end
	end
end
