-- 顶端资源栏
Lua_DivineDomainTrialItemTopPanel = class("Lua_DivineDomainTrialItemTopPanel", Lua_DisplayObject);
function Lua_DivineDomainTrialItemTopPanel:ctor(p)
	self:superCall("ctor", p);
end

function Lua_DivineDomainTrialItemTopPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.topBg = UICreate.createUIAtlasImage(self.content, "common_altas_3", "xui_common_widget_036", 0, -28, 720, 55);
	self.topBg.anchorValue = 1;
end

function Lua_DivineDomainTrialItemTopPanel:setData(moneyTypeList)
	if moneyTypeList == nil then
		return;
	end

	local count;
	if type(moneyTypeList) == "table" then
		count = #moneyTypeList;
	elseif type(moneyTypeList) == "Array" then
		count = moneyTypeList:getSize();
	else
		return;
	end

	if self.moneyItemList == nil then
		self.moneyItemList = {};
	end

	local item;
	local distance = 190;
	local startPosX = 259;
	local posX;
	local posY = -26;

	for i = 1, count do
		item = self.moneyItemList[i];
		if item == nil then
			item = Lua_MoneyItem.new(self.content);
			self.moneyItemList[i] = item;
		end
		posX = startPosX - distance * (i - 1);
		item:setEnable(true);
		item:setLocation(posX, posY);
		item:setCanClick(true);
		item:setMoney(moneyTypeList[i]);
	end

	local listCount = #self.moneyItemList;
	if count < listCount then
		for i = count + 1, listCount do
			item = self.moneyItemList[i];
			item:setEnable(false);
		end
	end

end

function Lua_DivineDomainTrialItemTopPanel:dispose()
	if self.topBg ~= nil then
		self.topBg:dispose();
		self.topBg = nil;
	end
	if self.moneyItemList ~= nil then
		for i = 1, #self.moneyItemList do
			self.moneyItemList[i]:dispose();
			self.moneyItemList[i] = nil;
		end
		self.moneyItemList = nil;
	end

	self:superCall("dispose");
end