-- 神域试炼
checkRequire("Lua_DivineDomainTrialControlPanel")
Lua_DivineDomainTrialMainWindow = class("Lua_DivineDomainTrialMainWindow", Lua_Window);
function Lua_DivineDomainTrialMainWindow:ctor()
	self:superCall("ctor");

	self.isFullSizeWin = true;
    self.showBackBtn = true;
    self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
    self.isSingleShowWin = true;
    self.windowName = "Lua_DivineDomainTrialMainWindow";
end

function Lua_DivineDomainTrialMainWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.downBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_widget_005", 0, 0, 720, 121);
	self.downBg.pivot = Lua_WindowUtil.getPivot(7);
	self.downBg.anchor = Lua_WindowUtil.getAnchor(7);
	self.downBg:setLocation(0, -5, 0);
	self.downBg.siblingIndex = self.backBtn.siblingIndex;

	self.btnInfo = Array();
	self.btnInfo:add({ textAtlas = "divineDomainTrial_atlas", textUnOpenSprite = "xui_sysl_zgnbutton_1_d", textNormalSprite = "xui_sysl_zgnbutton_1_n", textSelectedSprite = "xui_sysl_zgnbutton_1_p", panel = Lua_DivineDomainTrialControlPanel }); 
	self.btnInfo:add({ textAtlas = "divineDomainTrial_atlas", textUnOpenSprite = "xui_sysl_zgnbutton_2_d", textNormalSprite = "xui_sysl_zgnbutton_2_n", textSelectedSprite = "xui_sysl_zgnbutton_2_p", gotoFunctionId = 1143 }); 
	self.btnInfo:add({ textAtlas = "divineDomainTrial_atlas", textUnOpenSprite = "xui_ghdk_zgnbutton_4_d", textNormalSprite = "xui_ghdk_zgnbutton_4_n", textSelectedSprite = "xui_ghdk_zgnbutton_4_p", gotoFunctionId = 1144 }); 
	
	self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
	self.btnList:setRectAnchor(7);
	self.btnList:setRectPivot(5)
	self.btnList:setLocation(360, 53.5, 0);
	self.btnList:setButtonStyle("common_altas_1", "ui_common_button_001_b", "ui_common_button_001_b", 118, 108, 0.01, 1);
	self.btnList:setButtonLine("common_altas_1", "ui_common_line_011", 2, 108, 0, 0, 1);
	self.btnList:setButtonItem(120, 108);
	self.btnList:setData(self.btnInfo);
	self.btnList:setClickCallBack(self, self.onBtnClick);

	self:addLuaEvent("DIVINEDOMAIN_TRIAL_SHOW_MODEL", self, self.showModel); -- 展示模型
	self:addLuaEvent("DIVINEDOMAIN_TRIAL_SELECT_TRIAL_TAB", self, self.selecetTrialTab); 
end

function Lua_DivineDomainTrialMainWindow:showWin(param)
	self.bDivineDomainTrialMainShowWin = true;
	self:superCall("showWin", param);

	if param.modelScenePanel then
		if self.modelScenePanel ~= nil and self.modelScenePanel ~= param.modelScenePanel then
            self.modelScenePanel:dispose();
            self.modelScenePanel = nil;
        end
        
		self.modelScenePanel = param.modelScenePanel
		self.modelScenePanel:setParent(self.content)
		self.modelScenePanel:setRotBgDimensions(720, 720)
		self.modelScenePanel:setRotBgPos(0, 130)
		param.modelScenePanel = nil
	end

	local index;
	local subTabIndex = 1;
	self.subTabIndex = nil;
	if type(param) == "table" then
		index = param.main_id;
		self.subTabIndex = param.subTabIndex;
	else
		index = param;
	end

	self.btnList:setSelected(index);
end

function Lua_DivineDomainTrialMainWindow:selecetTrialTab()
	if self.showPanel ~= nil and self.showPanel.selectedPanel ~= nil and self.subTabIndex then
		self.showPanel:selectedPanel(self.subTabIndex);
		self.subTabIndex = nil;
	end
end

function Lua_DivineDomainTrialMainWindow:onBtnClick(index)
	if self.selectedIdx == index then
		return;
	end

	local data = self.btnInfo[index];
	local panelStr = data.panel;	
	if panelStr ~= nil then
		if self.panelDic == nil then
			self.panelDic = {};
		end

		local panel = self.panelDic[panelStr];
		if panel == nil then
			panel = panelStr.new(self.content);
			panel:setSiblingIndex(1);
			panel:setRectAnchor(9);
			self.panelDic[panelStr] = panel;
		end

		panel:setEnable(true);
		panel:onScreenResize(self.adaptHeight)
		if self.showPanel ~= nil and self.showPanel ~= panel then
			self.showPanel:setEnable(false);
		end
		self.showPanel = panel;
	else
		local gotoFunctionId = data.gotoFunctionId;
		if gotoFunctionId ~= nil then
			DataCenter.funcPathUtil:gotoFunction(gotoFunctionId);
		end
		self.btnList:setSelected(self.selectedIdx);
		return;
	end

	if self.showPanel.updateData ~= nil then
		self.showPanel:updateData();
	end

	self.selectedIdx = index;
end

-- 模型展示
function Lua_DivineDomainTrialMainWindow:showModel(trialId)
	self.trialId = trialId;
	if trialId == nil and self.modelScenePanel ~= nil then
		self.modelScenePanel:setModelEnable(false);
		return;
	end

	local cfg = DataCenter.divineDomainTrialUtil:getDivineDomainTrialConfig(trialId);
	if cfg == nil then
		return;
	end

	local heroVo = Lua_HeroVo.new(cfg.hero_id);
	if heroVo == nil then
		if self.modelScenePanel ~= nil then
			self.modelScenePanel:setModelEnable(false);
		end
		return
	end

	if not self.bDivineDomainTrialMainShowWin then
		return;
	end
	
	-- local heroVo = mondelData.heroVo;
	if self.modelScenePanel == nil then
		self.modelScenePanel = Lua_ModelScenePanel.new();
		self.modelScenePanel:setParent(self.content);
		self.modelScenePanel:setRotBgDimensions(720, 720);
		self.modelScenePanel:setRotBgPos(0, 130);
	end

	self.modelScenePanel.rotBg.siblingIndex = 0;
	local sceneId = cfg.scene_id;
	self.modelScenePanel:addActIdEffs(Lua_ThingDefine.UIWAIT, heroVo.poseActEffs);
	self.modelScenePanel:addActIdEffs(Lua_ThingDefine.UISHOW, heroVo.showActEffs);
	self.modelScenePanel:showModelScene(sceneId, heroVo.uiModelUrl, heroVo.uiModelAvatarName, heroVo.uiModelCamController, true)
	self.modelScenePanel:setModelAct(heroVo.uiShowAct, Lua_ThingDefine.UIWAIT, true);
	self.modelScenePanel:setModelDir(heroVo.uiModelDir);
	self.modelScenePanel:setModelScale(heroVo.uiModelScale);
end

function Lua_DivineDomainTrialMainWindow:resetActive(bActive)
    self:superCall("resetActive", bActive);
    if bActive then -- 显示
        if self.trialId ~= nil then
            self:showModel(self.trialId);
        end
    else
        if self.modelScenePanel ~= nil then
            self.modelScenePanel:dispose();
            self.modelScenePanel = nil;
        end
    end
end

function Lua_DivineDomainTrialMainWindow:dispose()
	DataCenter.divineDomainTrialData:resetSendMSg();
	if self.modelEffImg ~= nil then
		self.modelEffImg:dispose();
		self.modelEffImg = nil;
	end
	if self.modelScenePanel ~= nil then
		self.modelScenePanel:dispose()
		self.modelScenePanel = nil
	end
	if self.btnInfo ~= nil then
		self.btnInfo:dispose();
		self.btnInfo:clear();
		self.btnInfo = nil;
	end
	if self.downBg ~= nil then 
		self.downBg:dispose();
		self.downBg = nil;
	end
	if self.btnList ~= nil then 
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.panelDic ~= nil then
		for k, v in pairs(self.panelDic) do
			v:dispose();
			v = nil;
		end
		self.panelDic = nil;
	end
	self.showPanel = nil;
	self:superCall("dispose");
end