-- 神域试炼排行奖励
Lua_DivineDomainTrialRankRewardWindow = class("Lua_DivineDomainTrialRankRewardWindow", Lua_Window)
function Lua_DivineDomainTrialRankRewardWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_DivineDomainTrialRankRewardWindow";
	self.skinName = "DivineDomainTrialRankRewardWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_DivineDomainTrialRankRewardWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.itemList = Lua_DragList.new(self.content, 630, 720, Lua_AxisDefine.Vertical);
	self.itemList:setLocation(0, -98, 0);
	self.itemList:setListCell(Lua_DivineDomainTrialRankRewardItem, 630, 120, 1);
	self.itemList:setCellSpacing(0, 5);

	local config = getConfig("domain_trial_rank");--DataCenter.chaosForestUtil:getRankRewardConfig();
	self.itemList:setArrayData(config);
end

function Lua_DivineDomainTrialRankRewardWindow:dispose()
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	self:superCall("dispose");
end























Lua_DivineDomainTrialRankRewardItem = class("Lua_DivineDomainTrialRankRewardItem", Lua_ListCell)
function Lua_DivineDomainTrialRankRewardItem:ctor(p)
	self:superCall("ctor", p, "DivineDomainTrialRankRewardItem_skin");
end

function Lua_DivineDomainTrialRankRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemList = Lua_ItemIconList.new(self.content);
	self.itemList:setLocation(-55, 0, 0);
	self.itemList.pivot = 1;
	self.itemList.scaleVal = 0.75;
end

function Lua_DivineDomainTrialRankRewardItem:dispose()
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	self:superCall("dispose");
end

function Lua_DivineDomainTrialRankRewardItem:setData(data)
	if data == nil then
		return;
	end

	if data.rank[1] <= 3 then
		self.rankIcon:setAltas("common_altas_4", "xui_jys_label_1"..(data.rank[1] - 1));
		self.rankText:setEnable(false);
	else
		self.rankIcon:setAltas("common_altas_4", "xui_jys_label_13");
		self.rankText:setEnable(true);
		self.rankText.fontSize = 30;
		self.rankText.colorStr = Lua_ColorDefine.transColorStr("FFFFFF");
		self.rankText.effectStyle = 2;
		self.rankText.effectColorStr = Lua_ColorDefine.transColor("3E3B44");
		self.rankText:setEffectDistance(2, 2);
		self.rankText:setLocation(-256.5, 1.5, 0);
		if data.rank[1] == data.rank[2] then
			self.rankText.text = data.rank[1];
		else
			self.rankText.text = LanUtil.formateStr(10052, tostring(data.rank[1]), tostring(data.rank[2]));
		end
		self.rankText.fontSize = data.font_size;
	end

	self.itemList:setArrayData(data.reward);
end

function Lua_DivineDomainTrialRankRewardItem:onPressClick()
	self.itemList:onBoundClick();
end