-- 神域试炼阵容推荐
checkRequire("Lua_DivineDomainTrialRecordItem");
checkRequire("Lua_DivineDomainTrialBossSkillItem");
Lua_DivineDomainTrialRecommendWindow = class("Lua_DivineDomainTrialRecommendWindow", Lua_Window);
function Lua_DivineDomainTrialRecommendWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
	self.windowName = "Lua_DivineDomainTrialRecommendWindow";
	self.skinName = "DivineDomainTrialRecommendWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_DivineDomainTrialRecommendWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.descTxt_1:setLangValue(764050);
	self.descTxt_2:setLangValue(764051)

	self.recordItem = Lua_DivineDomainTrialRecordItem.new(self.content);
	self.recordItem:setScale(0.86, 0.86);
	self.recordItem:setLocation(0, -361);

	self.recommendList = Lua_DragList.new(self.content, 503, 275, Lua_AxisDefine.Vertical);
	self.recommendList:setListCell(Lua_DivineDTRecommendItem, 503, 206, 1);
    self.recommendList:setLocation(0, -86, 0);
end

function Lua_DivineDomainTrialRecommendWindow:showWin(param)
	self:superCall("showData", param);

	self.domainType = param.domain;
	self.recordItem:setData(param.record);

	local cfg = DataCenter.divineDomainTrialUtil:getDivineDomainTrialConfig(self.domainType);
	if cfg == nil then
		return;
	end

	local skills = DataCenter.divineDomainTrialUtil:getShowSkillByTrialId(self.domainType); 
	self:showSkills(skills);
	self:showBoss(cfg.recommmend_boss_url);
	self.bossDescTxt.text = cfg.recommend_desc;
	self.recommendList:setArrayData(cfg.recommend_heros);

end

function Lua_DivineDomainTrialRecommendWindow:dispose()
	if self.modelEffImg ~= nil then
		self.modelEffImg:dispose();
		self.modelEffImg = nil;
	end
	if self.skills ~= nil then
		for i = 1, #self.skills do
			self.skills[i]:dispose();
			self.skills[i] = nil;
		end
		self.skills = nil;
	end
	if self.recommendList ~= nil then
		self.recommendList:dispose();
		self.recommendList = nil;
	end
	if self.recordItem ~= nil then
		self.recordItem:dispose();
		self.recordItem = nil;
	end
	self:superCall("dispose");
end

function Lua_DivineDomainTrialRecommendWindow:showSkills(skills)
	skills = skills or {};
	if self.skills == nil then
		self.skills = {};
	end

	local item;
	local config;
	local startPosX, distanceX = 21, 67;
	local posX;
	for i = 1, #skills do
		item = self.skills[i];
		if item == nil then
			item = Lua_DivineDomainTrialBossSkillItem.new(self.content);
			item:setCanClick(true);
			item:setScale(0.58, 0.58);
			self.skills[i] = item;
		end
		posX = startPosX + (i - 1) * distanceX;
		item:setEnable(true);
		item:setData(skills[i]);
		item:setLocation(posX, 330);
	end

	if #self.skills > #skills then
		for i = #skills + 1, #self.skills do
			self.skills[i]:setEnable(false);
		end
	end
end

function Lua_DivineDomainTrialRecommendWindow:showBoss(bossUrl)
	if self.bossImg.url ~= bossUrl then
		self.bossImg:SetDimensions(0, 0);
		self.bossImg:setUrl(bossUrl);
	end
end










--------------------------------------------------------------------------



Lua_DivineDTRecommendItem = class("Lua_DivineDTRecommendItem", Lua_ListCell);
function Lua_DivineDTRecommendItem:ctor(p)
	self:superCall("ctor", p, "DivineDTRecommendItem_skin");
end

function Lua_DivineDTRecommendItem:buildShowItem()
	self:superCall("buildShowItem");

	self.dragList = Lua_DragList.new(self.content, 471, 75, Lua_AxisDefine.Horizontal);
	self.dragList:setListCell(Lua_DivineDTRecommendHeroItem, 75, 75, 1);
	self.dragList:setLocation(0, 28, 0);
	self.dragList:setCellSpacing(0, 10);
	self:setSubList(self.dragList);
end

function Lua_DivineDTRecommendItem:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	self:superCall("dispose");
end

function Lua_DivineDTRecommendItem:setData(data)
	self.data = data;

	if data == nil then
		return;
	end

	local cfg = getConfig("domain_trial_recommend", data);
	if cfg == nil then
		return;
	end

	self.titleNameTxt.text = cfg.type;
	self.descTxt.text = cfg.desc;
	self.dragList:setArrayData(cfg.heros);
end



--------------------------------------------------------------------------


Lua_DivineDTRecommendHeroItem = class("Lua_DivineDTRecommendHeroItem", Lua_ListCell);
function Lua_DivineDTRecommendHeroItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_DivineDTRecommendHeroItem:buildShowItem()
	self:superCall("buildShowItem");

	self.heroItem = Lua_ItemIcon.new(self.content);
	self.heroItem:setScale(0.6, 0.6);
end

function Lua_DivineDTRecommendHeroItem:dispose()
	if self.heroItem ~= nil then
		self.heroItem:dispose();
		self.heroItem = nil;
	end
	self:superCall("dispose");
end

function Lua_DivineDTRecommendHeroItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	local heroVo = Lua_HeroVo.new(self.data);
	self.heroItem:setData(heroVo);
end