-- 神域试炼记录阵容
Lua_DivineDomainTrialRecordItem = class("Lua_DivineDomainTrialRecordItem", Lua_DisplayObject);
function Lua_DivineDomainTrialRecordItem:ctor(p)
	self:superCall("ctor", p, "DivineDomainTrialRecordItem_skin");
end

function Lua_DivineDomainTrialRecordItem:buildShowItem()
	self:superCall("buildShowItem");

	self.avatarItem = Lua_AvatarItem.new(self.content);
	self.avatarItem:setScale(0.7, 0.7, 1);
	self.avatarItem:setLocation(-244, -19, 0);

	self.dragList = Lua_DragList.new(self.content, 379, 59, Lua_AxisDefine.Horizontal);
	self.dragList:setListCell(Lua_DivineDomainTrialRecordHeroItem, 59, 59, 1);
	self.dragList:setLocation(29, -28, 0);
	self.dragList:setCellSpacing(0, 10);

	self.rePlaySp:addClickFuntion(self, self.onClickRePlaySp);
end

function Lua_DivineDomainTrialRecordItem:dispose()
	if self.avatarItem ~= nil then
		self.avatarItem:dispose();
		self.avatarItem = nil;
	end
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	self:superCall("dispose");
end

function Lua_DivineDomainTrialRecordItem:setData(data)
	if data == nil then
		return;
	end
	self.data = data;
	-- self.trialId = 
	self:showRecordType();
	self:showPlayer();

end

function Lua_DivineDomainTrialRecordItem:showRecordType()
	local sprite = "xui_sysl_label_2";
	if self.data.type == 1 then -- 首通
		sprite = "xui_sysl_label_2";
	elseif self.data.type == 2 then -- 最近
		sprite = "xui_sysl_label_3";
	elseif self.data.type == 3 then -- 战力最低
		sprite = "xui_sysl_label_4";
	end

	self.titleSp:setAltas("divineDomainTrial_atlas", sprite);
end

function Lua_DivineDomainTrialRecordItem:showPlayer()
	local nonePassStr;
	local playerName;
	local forceStr = tonumber(self.data.force or 0);
	local record_id = tonumber(self.data.record_id or 0);
	if record_id == nil or record_id <= 0 then
		nonePassStr = LanUtil.getValue(764039);
		self.avatarItem:init();
		self.playerInfoObj:SetActive(false);
	else
		local info = self.data.show_role;
		playerName = info.name;
		
		self.avatarItem:setRoleId(info.id);
		self.avatarItem:setRoleDressUp(info.dress_info, true);
		self.avatarItem:setRoleLevel2(info.level);
		self.dragList:setArrayData(self.data.hero_list);
		self.playerInfoObj:SetActive(true);
	end
	self.nonePlayerTxt.text = nonePassStr;
	self.playerNameTxt.text = playerName;
	self.forceTxt.text = forceStr;
end

function Lua_DivineDomainTrialRecordItem:onClickRePlaySp()
	if self.data ~= nil then
		if self.clickTime ~= nil and getTime() - self.clickTime < 0.5 then
			OperateAlert.showLangValue(764012);
			return;
		end
		self.clickTime = getTime();

		-- 发送战斗记录申请
		local recordId = tonumber(self.data.record_id);
		Lua_ProxyManager.getProxy("Lua_FightProxy"):sFightReplay(recordId);
	end
end










--------------------------------

Lua_DivineDomainTrialRecordHeroItem = class("Lua_DivineDomainTrialRecordHeroItem", Lua_ListCell);
function Lua_DivineDomainTrialRecordHeroItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_DivineDomainTrialRecordHeroItem:buildShowItem()
	self:superCall("buildShowItem");

	self.heroItem = Lua_ItemIcon.new(self.content);
	self.heroItem:setScale(0.48, 0.48);
	-- self.heroItem:setClick(self, self.onItemClick);
end

function Lua_DivineDomainTrialRecordHeroItem:dispose()
	if self.heroItem ~= nil then
		self.heroItem:dispose();
		self.heroItem = nil;
	end
	self:superCall("dispose");
end

function Lua_DivineDomainTrialRecordHeroItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	local heroVo = Lua_HeroVo.new(tonumber(self.data.hero_id));
	heroVo:fromServer(self.data);
	self.heroItem:setData(heroVo);
end

-- function Lua_DivineDomainTrialRecordHeroItem:onPressClick()

-- ends