-- 神域试炼奖励窗口
Lua_DivineDomainTrialRewardWindow = class("Lua_DivineDomainTrialRewardWindow", Lua_Window);
function Lua_DivineDomainTrialRewardWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
	self.windowName = "Lua_DivineDomainTrialRewardWindow";
	self.skinName = "DivineDomainTrialRewardWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_DivineDomainTrialRewardWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.content, 630, 671, Lua_AxisDefine.Vertical);
	self.rewardList:setListCell(Lua_DivineDomainTrialRewardItem, 630, 171, 1);
    self.rewardList:setLocation(0, -30, 0);

    self:createTabList();
	self:addLuaEvent("UPDATE_DIVINEDOMAINTRIAL_REWARD", self, self.updateList); -- 刷新列表
end

function Lua_DivineDomainTrialRewardWindow:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	if self.tabBtnList ~= nil then
		self.tabBtnList:dispose();
		self.tabBtnList = nil;
	end
	if self.tabInfo ~= nil then
		self.tabInfo:dispose();
		self.tabInfo:clear();
		self.tabInfo = nil;
	end

	self:superCall("dispose");
end

function Lua_DivineDomainTrialRewardWindow:createTabList()
	self.tabInfo = Array();
    self.tabInfo:add({ type = Lua_DivineDomainTrialUtil.FIGHTING_REWARD,    textStr = LanUtil.getValue(764024), redPointId = Lua_RedPointList.DivineDomainTrial_Special_Reward });
    self.tabInfo:add({ type = Lua_DivineDomainTrialUtil.ACHIEVEMENT_REWARD, textStr = LanUtil.getValue(764025), redPointId = Lua_RedPointList.DivineDomainTrial_Achieve_Reward });

    self.tabBtnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
    self.tabBtnList:setLocation(6, -436, 0)
	self.tabBtnList:setButtonCell(Lua_CommonButtonItem2)
	self.tabBtnList:setRedPoint(72, 22)
	self.tabBtnList:setButtonItem(160, 67)
	self.tabBtnList:setClickCallBack(self, self.onTabBtnClick)
	self.tabBtnList:setData(self.tabInfo)
    self.tabBtnList:setSelected(1);
end

function Lua_DivineDomainTrialRewardWindow:onTabBtnClick(index)
	if self.selectedIndex == index then
		return;
	end

	self.selectedIndex = index;

	self:updateList(true);
end

function Lua_DivineDomainTrialRewardWindow:updateList(bMoveToFirst)
	local btnData = self.tabInfo[self.selectedIndex];
	if btnData == nil then
		return;
	end

	local type = btnData.type or Lua_DivineDomainTrialUtil.FIGHTING_REWARD;
	local idList = DataCenter.divineDomainTrialData:getSortedRewardIdsByType(type) or {};

	DataCenter.divineDomainTrialData.curRewardSelectedIndex = self.selectedIndex;
	idList = idList ~= nil and idList or {};
	self.rewardList:setArrayData(idList);

	if bMoveToFirst then
		self.rewardList:moveToIndex(1, true);
	end
end






















----------------------------------------------------------------

Lua_DivineDomainTrialRewardItem = class("Lua_DivineDomainTrialRewardItem", Lua_ListCell);
function Lua_DivineDomainTrialRewardItem:ctor(p)
	self:superCall("ctor", p, "DivineDomainTrialRewardItem_skin");
end

function Lua_DivineDomainTrialRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.content, 409, 104, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_DivineDomainTrialRewardSubItem, 99, 99, 1);
    self.rewardList:setLocation(-85, -18, 0);
    self:setSubList(self.rewardList);

    self.receiveBtn:addClickFuntion(self, self.onClickReceiveBtn)
end

function Lua_DivineDomainTrialRewardItem:dispose()
	self:superCall("dispose");
end

function Lua_DivineDomainTrialRewardItem:setData(data)
	self.data = data;

	if data == nil then
		return;
	end

	local cfg = DataCenter.divineDomainTrialUtil:getDivineDomainTrialTaskCfg(data);
	if cfg == nil then
		return;
	end
	self.type = cfg.reset;

	local rewards = cfg.reward;
	local str = cfg.desc;
	self.titleNameTxt.text = str;
	self.rewardList:setArrayData(rewards or {});

	local rewardState = DataCenter.divineDomainTrialData:getRewardStateById(self.type, data);
	-- 0不可领取 1可领取 2已领取
	if rewardState == nil or rewardState == 0 then
		self.receiveBtn:setLangValue(764026);
		self.receiveBtn:setGray(true);
		self.receiveBtn:setEnable(true);
	elseif rewardState == 1 then
		self.receiveBtn:setLangValue(764027);
		self.receiveBtn:setGray(false);
		self.receiveBtn:setEnable(true);
	else
		self.receiveBtn:setEnable(false);
	end

	local bReceived = rewardState == 2;
	local totalCount = 1;
	local curCount = rewardState ~= 0  and 1 or 0;
	self.receiveSp:setEnable(bReceived);
	self.processTxt.text = not bReceived and LanUtil.formateStr(764028, curCount, totalCount) or nil;
end

function Lua_DivineDomainTrialRewardItem:onClickReceiveBtn()
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.5 then
		return;
	end
	self.clickTime = getTime();

	local rewardState = DataCenter.divineDomainTrialData:getRewardStateById(self.type, self.data);
	if rewardState == 1 then
		Lua_ProxyManager.getProxy("Lua_DivineDomainTrialProxy"):sReceiveAcheiveRewardInfo(self.data, self.type);
	end
end













-------------------------------------
Lua_DivineDomainTrialRewardSubItem = class("Lua_DivineDomainTrialRewardSubItem", Lua_ItemIconCell)
function Lua_DivineDomainTrialRewardSubItem:buildShowItem()
	self:superCall("buildShowItem")

	self.itemIcon:setScale(0.8, 0.8, 1)
end

function Lua_DivineDomainTrialRewardSubItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	local tvo = Lua_ToolVo.createToolVo(data[1], data[2]);
	self.itemIcon:setData(tvo);
end

function Lua_DivineDomainTrialRewardSubItem:onPressClick()
    if self.data == nil then
        return;
    end

    local tvo = Lua_ToolVo.createToolVo(self.data[1], self.data[2]);
    DataCenter.packUtil:showItemInfo(tvo);
end