-- 神域试炼 特殊副本boss提示窗口
checkRequire("Lua_DivineDomainTrialBossSkillItem");
Lua_DivineDomainTrialSpecialBossTipWindow = class("Lua_DivineDomainTrialSpecialBossTipWindow", Lua_Window);
function Lua_DivineDomainTrialSpecialBossTipWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
	self.windowName = "Lua_DivineDomainTrialSpecialBossTipWindow";
	self.skinName = "DivineDomainTrialSpecialBossTipWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_DivineDomainTrialSpecialBossTipWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.descTxt_1.text = getConfig("domain_trial_const", "special_boss_tip", "desc");
	self:showBossTipInfo();
	Lua_ProxyManager.getProxy("Lua_DivineDomainTrialProxy"):sNoticeBossReset(1); 
end

function Lua_DivineDomainTrialSpecialBossTipWindow:dispose()
	if self.skillItems ~= nil then
		for i = 1, #self.skillItems do
			self.skillItems[i]:dispose();
			self.skillItems[i] = nil;
		end
		self.skillItems = nil;
	end
	self:superCall("dispose");
end

function Lua_DivineDomainTrialSpecialBossTipWindow:showBossTipInfo()
	local specialTrialData = DataCenter.divineDomainTrialData:getSpecialTrialData();
	if specialTrialData == nil then
		return;
	end

	if self.skillItems == nil then
		self.skillItems = {};
	end
	local skills = specialTrialData.skills;
	local item;
	local posX;
	local startPosX, distanceX = -180, 180;
	for i = 1, #skills do
		item = self.skillItems[i];
		if item == nil then
			item = Lua_DivineDomainTrialBossSkillItem.new(self.content);
			item:setSkillItemScale(1, 1);
			self.skillItems[i] = item;
		end
		posX = startPosX + (i - 1) * distanceX;
		item:setData(skills[i]);
		item:setEnable(true);
		item:setLocation(posX, -26);
	end


	if #self.skillItems > #skills then
		for i = #skills + 1, #self.skillItems do
			self.skillItems[i]:setEnable(false);
		end
	end

	local str;
	local bossDiff = DataCenter.divineDomainTrialData.showNoticeBossDiff;
	if bossDiff ~= 0 then
		str = getConfig("domain_trial_const", "special_boss_up_tip", "desc");
		str = LanUtil.formateStr(str, bossDiff);
	end
	self.descTxt_2.text = str;
end